/*
 * AllTray.vala - Entrypoint for AllTray.
 * Copyright (c) 2009 Michael B. Trausch <mike@trausch.us>
 */

#ifndef __ALLTRAY_H__
#define __ALLTRAY_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

G_BEGIN_DECLS


#define ALL_TRAY_TYPE_PROGRAM (all_tray_program_get_type ())
#define ALL_TRAY_PROGRAM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ALL_TRAY_TYPE_PROGRAM, AllTrayProgram))
#define ALL_TRAY_PROGRAM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ALL_TRAY_TYPE_PROGRAM, AllTrayProgramClass))
#define ALL_TRAY_IS_PROGRAM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ALL_TRAY_TYPE_PROGRAM))
#define ALL_TRAY_IS_PROGRAM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ALL_TRAY_TYPE_PROGRAM))
#define ALL_TRAY_PROGRAM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ALL_TRAY_TYPE_PROGRAM, AllTrayProgramClass))

typedef struct _AllTrayProgram AllTrayProgram;
typedef struct _AllTrayProgramClass AllTrayProgramClass;
typedef struct _AllTrayProgramPrivate AllTrayProgramPrivate;

typedef enum  {
	ALL_TRAY_ALL_TRAY_ERROR_FAILED
} AllTrayAllTrayError;
#define ALL_TRAY_ALL_TRAY_ERROR all_tray_all_tray_error_quark ()
struct _AllTrayProgram {
	GObject parent_instance;
	AllTrayProgramPrivate * priv;
};

struct _AllTrayProgramClass {
	GObjectClass parent_class;
};


GQuark all_tray_all_tray_error_quark (void);
AllTrayProgram* all_tray_program_construct (GType object_type, char*** args, int* args_length1);
AllTrayProgram* all_tray_program_new (char*** args, int* args_length1);
char** all_tray_program_command_line_init (AllTrayProgram* self, char*** args, int* args_length1, int* result_length1);
gint all_tray_program_run (AllTrayProgram* self);
gint all_tray_program_main (char** args, int args_length1);
char** all_tray_program_get_args (AllTrayProgram* self);
GType all_tray_program_get_type (void);


G_END_DECLS

#endif
