/*
 * Application.vala - Application-based window management for AllTray
 * Copyright (c) 2009 Michael B. Trausch <mike@trausch.us>
 * License: GNU GPL v3.0 as published by the Free Software Foundation
 */

#ifndef __APPLICATION_H__
#define __APPLICATION_H__

#include <glib.h>
#include <glib-object.h>
#include <libwnck/libwnck.h>
#include "Process.h"

G_BEGIN_DECLS


#define ALL_TRAY_TYPE_APPLICATION (all_tray_application_get_type ())
#define ALL_TRAY_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ALL_TRAY_TYPE_APPLICATION, AllTrayApplication))
#define ALL_TRAY_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ALL_TRAY_TYPE_APPLICATION, AllTrayApplicationClass))
#define ALL_TRAY_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ALL_TRAY_TYPE_APPLICATION))
#define ALL_TRAY_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ALL_TRAY_TYPE_APPLICATION))
#define ALL_TRAY_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ALL_TRAY_TYPE_APPLICATION, AllTrayApplicationClass))

typedef struct _AllTrayApplication AllTrayApplication;
typedef struct _AllTrayApplicationClass AllTrayApplicationClass;
typedef struct _AllTrayApplicationPrivate AllTrayApplicationPrivate;

typedef enum  {
	ALL_TRAY_APPLICATION_ERROR_FAILED
} AllTrayApplicationError;
#define ALL_TRAY_APPLICATION_ERROR all_tray_application_error_quark ()
struct _AllTrayApplication {
	GObject parent_instance;
	AllTrayApplicationPrivate * priv;
};

struct _AllTrayApplicationClass {
	GObjectClass parent_class;
};


GQuark all_tray_application_error_quark (void);
AllTrayApplication* all_tray_application_construct (GType object_type, AllTrayProcess* p);
AllTrayApplication* all_tray_application_new (AllTrayProcess* p);
gboolean all_tray_application_get_wapp (AllTrayApplication* self);
void all_tray_application_toggle_visibility (AllTrayApplication* self);
WnckApplication* all_tray_application_get_wnck_app (AllTrayApplication* self);
GType all_tray_application_get_type (void);


G_END_DECLS

#endif
