/*
 * Process.vala - Child process management
 * Copyright (c) 2009 Michael B. Trausch <mike@trausch.us>
 * License: GNU GPL v3.0 as published by the Free Software Foundation
 */

#ifndef __PROCESS_H__
#define __PROCESS_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

G_BEGIN_DECLS


#define ALL_TRAY_TYPE_PROCESS (all_tray_process_get_type ())
#define ALL_TRAY_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ALL_TRAY_TYPE_PROCESS, AllTrayProcess))
#define ALL_TRAY_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ALL_TRAY_TYPE_PROCESS, AllTrayProcessClass))
#define ALL_TRAY_IS_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ALL_TRAY_TYPE_PROCESS))
#define ALL_TRAY_IS_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ALL_TRAY_TYPE_PROCESS))
#define ALL_TRAY_PROCESS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ALL_TRAY_TYPE_PROCESS, AllTrayProcessClass))

typedef struct _AllTrayProcess AllTrayProcess;
typedef struct _AllTrayProcessClass AllTrayProcessClass;
typedef struct _AllTrayProcessPrivate AllTrayProcessPrivate;

typedef enum  {
	ALL_TRAY_PROCESS_ERROR_SPAWN_FAILED,
	ALL_TRAY_PROCESS_ERROR_FAILED
} AllTrayProcessError;
#define ALL_TRAY_PROCESS_ERROR all_tray_process_error_quark ()
struct _AllTrayProcess {
	GObject parent_instance;
	AllTrayProcessPrivate * priv;
};

struct _AllTrayProcessClass {
	GObjectClass parent_class;
};


GQuark all_tray_process_error_quark (void);
AllTrayProcess* all_tray_process_construct (GType object_type, char** argv, int argv_length1);
AllTrayProcess* all_tray_process_new (char** argv, int argv_length1);
GPid all_tray_process_get_pid (AllTrayProcess* self);
void all_tray_process_run (AllTrayProcess* self);
void all_tray_process_child_died (AllTrayProcess* self);
gboolean all_tray_process_get_running (AllTrayProcess* self);
GType all_tray_process_get_type (void);


G_END_DECLS

#endif
