/*
 * TrayIcon.vala - Tray icon management
 * Copyright (c) 2009 Michael B. Trausch <mike@trausch.us>
 * License: GNU GPL v3.0 as published by the Free Software Foundation
 */

#ifndef __TRAYICON_H__
#define __TRAYICON_H__

#include <glib.h>
#include <glib-object.h>
#include "Process.h"
#include "Application.h"

G_BEGIN_DECLS


#define ALL_TRAY_TYPE_TRAY_ICON (all_tray_tray_icon_get_type ())
#define ALL_TRAY_TRAY_ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ALL_TRAY_TYPE_TRAY_ICON, AllTrayTrayIcon))
#define ALL_TRAY_TRAY_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ALL_TRAY_TYPE_TRAY_ICON, AllTrayTrayIconClass))
#define ALL_TRAY_IS_TRAY_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ALL_TRAY_TYPE_TRAY_ICON))
#define ALL_TRAY_IS_TRAY_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ALL_TRAY_TYPE_TRAY_ICON))
#define ALL_TRAY_TRAY_ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ALL_TRAY_TYPE_TRAY_ICON, AllTrayTrayIconClass))

typedef struct _AllTrayTrayIcon AllTrayTrayIcon;
typedef struct _AllTrayTrayIconClass AllTrayTrayIconClass;
typedef struct _AllTrayTrayIconPrivate AllTrayTrayIconPrivate;

typedef enum  {
	ALL_TRAY_TRAY_ICON_ERROR_FAILED
} AllTrayTrayIconError;
#define ALL_TRAY_TRAY_ICON_ERROR all_tray_tray_icon_error_quark ()
struct _AllTrayTrayIcon {
	GObject parent_instance;
	AllTrayTrayIconPrivate * priv;
};

struct _AllTrayTrayIconClass {
	GObjectClass parent_class;
};


GQuark all_tray_tray_icon_error_quark (void);
AllTrayTrayIcon* all_tray_tray_icon_construct (GType object_type, AllTrayProcess* process, AllTrayApplication* application);
AllTrayTrayIcon* all_tray_tray_icon_new (AllTrayProcess* process, AllTrayApplication* application);
gboolean all_tray_tray_icon_get_app_info_retry (AllTrayTrayIcon* self);
void all_tray_tray_icon_on_click (AllTrayTrayIcon* self);
GType all_tray_tray_icon_get_type (void);


G_END_DECLS

#endif
